/*****************************************************************************
  FILE           : kr_amap.h
  SHORTNAME      : 
  SNNS VERSION   : 3.2

  PURPOSE        : SNNS Kernel Function Prototypes for ARTMAP-Networks
  NOTES          :

  AUTHOR         : Kai-Uwe Herrmann
  DATE           : 17.05.92

  CHANGED BY     : Sven Doering
  IDENTIFICATION : @(#)kr_amap.h	1.8 3/15/94
  SCCS VERSION   : 1.8
  LAST CHANGE    : 3/15/94

             Copyright (c) 1990-1994  SNNS Group, IPVR, Univ. Stuttgart, FRG

******************************************************************************/
#ifndef _KR_AMAP_DEFINED_
#define  _KR_AMAP_DEFINED_




extern int             ArtMap_NoOfInpUnits_a;
extern int             ArtMap_NoOfInpUnits_b;
extern int             ArtMap_NoOfRecUnits_a;
extern int             ArtMap_NoOfRecUnits_b;

extern struct Unit    *ArtMap_cl_unit;  /* Pointer to cl-unit */
extern struct Unit    *ArtMap_nc_unit;  /* Pointer to nc-unit */




/***************************************************************************/
/* kram_init_i_act ()

   Sets the initial activation values of the units
*/
 krui_err kram_init_i_act (

                                 double rho_a,
                                 double rho_b,
                                 double rho

                                );


/***************************************************************************/
/* kram_sort ()

   Check for ARTMAP topology and create topo ptr array
*/
 krui_err  kram_sort (

                            void

                           );




/***************************************************************************/
/* kram_getClassNo ()

   Returns the number of the actually activated class K, 1 <= K <= Mb
*/
 int  kram_getClassNo (

                             void

                            );



/***************************************************************************/
/* kram_AllMapUnitsActive ()

   Returns TRUE, if all MAP-Field-Units are active, else, FALSE
*/
 bool  kram_AllMapUnitsActive (

                                     void

                                    );




#endif 

/* 94 lines generated by deleteprivatedefinitions.awk */
