/*****************************************************************************
  FILE           : kr_pat_parse.ph
  SHORTNAME      : pat_parse
  SNNS VERSION   : 3.2

  PURPOSE        : parser for new pattern format; bison format 
  NOTES          : impossible to use with yacc

  AUTHOR         : Michael Vogt
  DATE           : 10.9.93

  CHANGED BY     : 
  IDENTIFICATION : @(#)kr_pat_parse.ph	1.3 3/15/94
  SCCS VERSION   : 1.3
  LAST CHANGE    : 3/15/94

             Copyright (c) 1990-1994  SNNS Group, IPVR, Univ. Stuttgart, FRG

******************************************************************************/

#ifndef _KR_PAT_PARSE_DEFINED_
#define _KR_PAT_PARSE_DEFINED_

/* begin global definition section */

#define CURRENT_VERSION_V       3  /* current version of pattern file        */
#define CURRENT_VERSION_R       2  /* format                                 */

int parse_pattern_file(int *set);


/* end global definition section */

/* begin private definition section */

static int	i;
static int	dims[MAX_NO_OF_VAR_DIM];
static int	max_i_dims[MAX_NO_OF_VAR_I_DIM];
static int	max_o_dims[MAX_NO_OF_VAR_O_DIM];
static int	actual_dim_count;
static int	variable_input_dim;
static int	variable_output_dim;
static int	current_pattern;
static int	next_pattern_is_input;
static int	no_of_input;
static int	no_of_output;
static int	no_of_pattern;
static int	act_size;
static float	*pat_mem;
static int      pattern_set;
static pattern_descriptor *pattern;

static void yyerror(char *error);

/* end private definition section */

#endif

